#include <malloc.h>
#include <stdlib.h>
#include <memory.h>
#include "stack.h"
#include "board.h"
#include "main.h"

struct ch_board *board_clone(struct ch_board *oldboard)
{
    struct ch_board *newboard;

    if (oldboard==NULL) return NULL; /* return null if parent is null*/
    else {
	newboard = malloc(sizeof(struct ch_board));
	memcpy(newboard, oldboard, sizeof(struct ch_board));
	return newboard; /*else create new and copy parents info to it*/
    }
}
void board_free(struct ch_board *ob)
{
    if (ob != NULL){
	free(ob);
	/*free old boards memory usage "i hope" */
    }
}
struct ch_board *board_init(){
    int i;
    struct ch_board *newboard;
    newboard=malloc(sizeof(struct ch_board));
    for (i=0;i<10;i++) { 
	newboard -> square[i] = B_INVAL;
	newboard -> square[i+90] = B_INVAL;
    }

    /* set the top & botom lines */
    for (i=10;i<101;i+=10) {
	newboard -> square[i] = B_INVAL;
	newboard -> square[i+9] = B_INVAL;
    }

    /* set the right & left colums */

    for (i=12;i< B_END ;i+=2){
	newboard -> square[i] = B_EMPTY;
	if ( (i==18) || (i==38) || (i==58) || (i==78) ) i+=2;
	else if ( (i==27) || (i==47) || (i==67) ) i++;
    }

    /* sets the valid squares to B_EMPTY */
    for (i=B_START ;i< B_END ;i++) {
	if (newboard -> square[i] == B_EMPTY) {
	    if (i < 39) newboard -> square[i] = B_BLACK;
	    else if (i > 60) newboard -> square[i] = B_WHITE;
	}
	else newboard -> square[i] = B_INVAL;
    }

    /* set the rest of the invalid squares and asign black & white markers 
       on the board */

    return newboard;
}

